#include "prjlibs-c/standards.h"
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>

#include "skalibs/include/stddjb.h"
#include "prjlibs-c/constants.h"
#include "fdtools.h"

char const* PROG="grabconsole";

static char const dev_console[]="/dev/console";

int main(int argc, char** argv) {
  int fd, scan;

  if (argc<2)
    strerr_die3x(100, usage, PROG, " file [program ...]");

  fd=scan_or_open(&scan, argv[1], O_RDONLY, 0);
  if (fd<0) {
    if (scan) strerr_die3x(100, PROG, ": descriptor malformed: ", argv[1]);
    else strerr_die5sys(errstat, PROG, err_unable, err_open, argv[1], ": ");
  }

  switch (grabconsole(fd)) {
    case grabconsole_success: break;
    case grabconsole_ioctl:
      strerr_die3sys(errstat, PROG, err_unable, "do ioctl: ");
    case grabconsole_devconsole_open:
      strerr_die5sys(errstat, PROG, err_unable, err_open, dev_console, ": ");
    case grabconsole_devconsole_close:
      strerr_die5sys(errstat, PROG, err_unable, err_close, dev_console, ": ");
    default:
      strerr_die3sys(100, PROG, err_unknown, ": ");
  }

  argv+=2;
  pathexec0((char const**)argv);
  strerr_die5sys(errstat, PROG, err_unable, err_exec, argv[0], ": ");
}
