#ifndef PACKAGE__PROG__PRJLIBS__WARNINGS_H
#define PACKAGE__PROG__PRJLIBS__WARNINGS_H

/* check the properties of a type or value without triggering a warning */
#define IS_SIGNED(type) ((type)-1<(type)1)
#define IS_UNSIGNED(type) (!IS_SIGNED(type))
#define IS_NEGATIVE(type, value) \
  ((type)(value)<(type)(IS_SIGNED(type)? 0: (value)))

/* trigger a warning (or error) if this value is not an array of this type */
#define CHK_ARR(type, value) \
  (0? (void)(*((type (**)[sizeof (value)/sizeof *(value)])0)=&(value)): \
      (void)0)
#define CHK_ARR_C(value)  CHK_ARR(char,       (value))
#define CHK_ARR_CC(value) CHK_ARR(char const, (value))

#endif
