#include "prjlibs-c/standards.h"
#include <unistd.h>
#include <limits.h>
#include <errno.h>

#include "skalibs/include/stddjb.h"
#include "prjlibs-c/constants.h"
#include "fdtools.h"

extern void check_exit_exec(char** argv);

char const* PROG="seek0";

int main(int argc, char** argv) {
  for (argv+=(argc!=0);; ++argv) {
    char const* const arg=*argv;
    unsigned int fd, len;

    check_exit_exec(argv);

    len=scan_uint(arg, &fd);
    if (len==0 || arg[len]!='\0' || fd>INT_MAX)
      strerr_die3x(100, PROG, ": descriptor malformed: ", arg);

    switch (seek0(fd)) {
      case seek0_success: break;
      case seek0_lseek:
        strerr_die3sys(errstat, PROG, err_unable, "lseek: ");
      default:
        strerr_die3sys(100, PROG, err_unknown, ": ");
    }
  }
}
